VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Groups Pages
Classes | Public Types | Public Member Functions | List of all members
CMultiLineTextLabel Class Reference
Version 4.5

Multi line text label. More...

Inheritance diagram for CMultiLineTextLabel:

## Public Types
enum | LineLayout { clip, truncate, wrap }
Public Types inherited from CTextLabel
enum | TextTruncateMode { kTruncateNone = 0, kTruncateHead, kTruncateTail }

## Public Member Functions
| CMultiLineTextLabel (const CRect &size)
| CMultiLineTextLabel (const CMultiLineTextLabel &)=default
void | setLineLayout (LineLayout layout)
LineLayout | getLineLayout () const
void | setAutoHeight (bool state)
| automatically resize the view according to the contents (only the height)
bool | getAutoHeight () const
| returns true if this view resizes itself according to the contents
void | setVerticalCentered (bool state)
| draw the lines vertical centered
bool | getVerticalCentered () const
| returns true if the view draws the lines vertically centered
CCoord | getMaxLineWidth ()
| return the maximum line width of all lines
void | drawRect (CDrawContext *pContext, const CRect &updateRect) override
| called if the view should draw itself
bool | sizeToFit () override
| resize view to optimal size
void | setText (const UTF8String &txt) override
| set text
void | setViewSize (const CRect &rect, bool invalid=true) override
| set views size
void | setTextTruncateMode (TextTruncateMode mode) override
| set text truncate mode
void | setValue (float val) override
Public Member Functions inherited from CTextLabel
| CTextLabel (const CRect &size, UTF8StringPtr txt=nullptr, CBitmap *background=nullptr, const int32_t style=0)
| CTextLabel constructor.
| CTextLabel (const CTextLabel &textLabel)
void | draw (CDrawContext *pContext) override
| called if the view should draw itself
void | valueChanged () override
| notifies listener and dependent objects
CBaseObject * | newCopy () const override
virtual const UTF8String & | getText () const
| read only access to text
TextTruncateMode | getTextTruncateMode () const
| get text truncate mode
const UTF8String & | getTruncatedText () const
| get the truncated text
void | registerTextLabelListener (ITextLabelListener *listener)
| register a text label listener
void | unregisterTextLabelListener (ITextLabelListener *listener)
| unregister a text label listener
Public Member Functions inherited from CParamDisplay
| CParamDisplay (const CRect &size, CBitmap *background=nullptr, int32_t style=0)
| CParamDisplay (const CParamDisplay &paramDisplay)
bool | getFocusPath (CGraphicsPath &outPath) override
| the graphics path will be drawn filled with the evenodd method and the color set in CFrame::setFocusColor()
bool | removed (CView *parent) override
| view is removed from parent view
virtual void | setFont (CFontRef fontID)
const CFontRef | getFont () const
virtual void | setFontColor (CColor color)
CColor | getFontColor () const
virtual void | setBackColor (CColor color)
CColor | getBackColor () const
virtual void | setFrameColor (CColor color)
CColor | getFrameColor () const
virtual void | setShadowColor (CColor color)
CColor | getShadowColor () const
virtual void | setShadowTextOffset (const CPoint &offset)
CPoint | getShadowTextOffset () const
virtual void | setAntialias (bool state)
bool | getAntialias () const
virtual void | setHoriAlign (CHoriTxtAlign hAlign)
CHoriTxtAlign | getHoriAlign () const
virtual void | setTextInset (const CPoint &p)
CPoint | getTextInset () const
virtual void | setTextRotation (double angle)
double | getTextRotation () const
virtual void | setRoundRectRadius (const CCoord &radius)
CCoord | getRoundRectRadius () const
virtual void | setFrameWidth (const CCoord &width)
CCoord | getFrameWidth () const
void | setValueToStringFunction (const ValueToStringFunction &valueToStringFunc)
void | setValueToStringFunction (ValueToStringFunction &&valueToStringFunc)
void | setValueToStringFunction2 (const ValueToStringFunction2 &valueToStringFunc)
void | setValueToStringFunction2 (ValueToStringFunction2 &&valueToStringFunc)
virtual void | setStyle (int32_t val)
int32_t | getStyle () const
virtual void | setPrecision (uint8_t precision)
uint8_t | getPrecision () const
virtual void | setBackOffset (const CPoint &offset)
const CPoint & | getBackOffset () const
void | copyBackOffset ()
Public Member Functions inherited from CControl
| CControl (const CRect &size, IControlListener *listener=nullptr, int32_t tag=0, CBitmap *pBackground=nullptr)
| CControl (const CControl &c)
bool | isDirty () const override
| check if view is dirty
void | setDirty (bool val=true) override
| set the view to dirty so that it is redrawn in the next idle.
bool | drawFocusOnTop () override
| draw focus before view will be drawn or afterwards
virtual float | getValue () const
virtual void | setValueNormalized (float val)
virtual float | getValueNormalized () const
virtual void | setMin (float val)
virtual float | getMin () const
virtual void | setMax (float val)
virtual float | getMax () const
float | getRange () const
virtual void | setOldValue (float val)
virtual float | getOldValue () const
virtual void | setDefaultValue (float val)
virtual float | getDefaultValue () const
virtual void | bounceValue ()
virtual void | setTag (int32_t val)
virtual int32_t | getTag () const
virtual void | beginEdit ()
virtual void | endEdit ()
bool | isEditing () const
virtual IControlListener * | getListener () const
| get main listener
virtual void | setListener (IControlListener *l)
| set main listener
void | registerControlListener (IControlListener *listener)
| register a sub listener
void | unregisterControlListener (IControlListener *listener)
| unregister a sub listener
virtual void | setWheelInc (float val)
virtual float | getWheelInc () const
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
void | setSubviewState (bool state)
bool | isSubview () const
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes
void | setTooltipText (UTF8StringPtr text)
virtual CViewContainer * | asViewContainer ()
virtual const CViewContainer * | asViewContainer () const
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
void | beforeDelete () override
CBaseObject * | newCopy () const override
virtual void | dispatchEvent (Event &event)
| dispatch an event
virtual void | onMouseDownEvent (MouseDownEvent &event)
| called when a mouse down event occurs
virtual void | onMouseMoveEvent (MouseMoveEvent &event)
| called when a mouse move event occurs
virtual void | onMouseUpEvent (MouseUpEvent &event)
| called when a mouse up event occurs
virtual void | onMouseCancelEvent (MouseCancelEvent &event)
| called when mouse tracking should be canceled
virtual void | onMouseEnterEvent (MouseEnterEvent &event)
| called when the mouse enters this view
virtual void | onMouseExitEvent (MouseExitEvent &event)
| called when the mouse leaves this view
virtual void | onMouseWheelEvent (MouseWheelEvent &event)
| called when a mouse wheel event occurs
virtual void | onZoomGestureEvent (ZoomGestureEvent &event)
| called when a zoom gesture event occurs
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse
CRect | getMouseableArea () const
| get the area in which the view reacts to the mouse
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseCancel ()
| do not use any longer.
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) final
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const Event &event=noEvent())
| check if where hits this view
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| A drag can only be started from within onMouseDown or onMouseMove.
virtual SharedPointer < IDropTarget > | getDropTarget ()
| get the drag target for drag and drop handling
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown
virtual void | onKeyboardEvent (KeyboardEvent &event)
| called when a keyboard event is dispatched to this view
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus
CCoord | getHeight () const
| get the height of the view
CCoord | getWidth () const
| get the width of the view
const CRect & | getViewSize () const
| read only access to view size
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view
virtual void | parentSizeChanged ()
| notification that one of the views parent has changed its size
virtual CPoint & | frameToLocal (CPoint &point) const
| conversion from frame coordinates to local view coordinates
virtual CPoint & | localToFrame (CPoint &point) const
| conversion from local view coordinates to frame coordinates
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags
int32_t | getAutosizeFlags () const
| get autosize flags
virtual void | looseFocus ()
| called if view should loose focus
virtual void | takeFocus ()
| called if view should take focus
virtual bool | wantsFocus () const
| check if view supports focus
virtual void | setWantsFocus (bool state)
| set focus support on/off
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute
template<typename T >
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute
template<typename T >
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute
virtual void | setBackground (CBitmap *background)
| set the background image of this view
CBitmap * | getBackground () const
| get the background image of this view
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state.
virtual void | setTransparency (bool val)
| set views transparent state
bool | getTransparency () const
| get views transparent state
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view
float | getAlphaValue () const
| get alpha value
virtual bool | attached (CView *parent)
| view is attached to a parent view
bool | isAttached () const
| is view attached to a parentView
CView * | getParentView () const
| get parent view
CFrame * | getFrame () const
| get frame
virtual VSTGUIEditorInterface * | getEditor () const
| get editor
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc=nullptr, bool callDoneOnCancel=false)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewEventListener (IViewEventListener *listener)
void | unregisterViewEventListener (IViewEventListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform (bool ignoreFrame=false) const
| get the active global transform for this view
template<typename T >
T & | translateToGlobal (T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T >
T | translateToGlobal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T >
T & | translateToLocal (T &t, bool ignoreFrame=false) const
| translates a global coordinate to a local one using parent transforms
template<typename T >
T | translateToLocal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
virtual bool | checkUpdate (const CRect &updateRect) const
virtual void | invalidRect (const CRect &rect)
| mark rect as invalid
virtual void | invalid ()
| mark whole view as invalid
virtual void | setVisible (bool state)
| set visibility state
bool | isVisible () const
| get visibility state
virtual void | onIdle ()
| called on idle when view wants idle
void | setWantsIdle (bool state)
| enable/disable onIdle() callback
bool | wantsIdle () const
| returns if the view wants idle callback or not
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexceptoverride=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
virtual CMessageResult | notify ([[maybe_unused]] CBaseObject *sender,[[maybe_unused]] IdStringPtr message)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
Public Member Functions inherited from IFocusDrawing
virtual | ~IFocusDrawing () noexcept=default

## Additional Inherited Members
Static Public Attributes inherited from CControl
static CheckDefaultValueEventFuncT | CheckDefaultValueEventFunc
| Function to check if a mouse down event should reset the value to its default value for a *control.
static int32_t | kZoomModifier = kShift
| zoom modifier key, per default is the shift key
static int32_t | kDefaultValueModifier = kControl
static CheckDefaultValueFuncT | CheckDefaultValueFunc
Protected Types inherited from CTextLabel
using | TextLabelListenerList = DispatchList< ITextLabelListener * >
Protected Member Functions inherited from CTextLabel
| ~CTextLabel () noexceptoverride=default
void | freeText ()
void | calculateTruncatedText ()
bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons) override
Static Protected Member Functions inherited from CControl
static int32_t | mapVstKeyModifier (int32_t vstModifier)
Protected Attributes inherited from CTextLabel
TextTruncateMode | textTruncateMode
UTF8String | text
UTF8String | truncatedText
std::unique_ptr < TextLabelListenerList > | listeners

## Detailed Description

Multi line text label.

## Member Enumeration Documentation

enum LineLayout

Enumerator
clip | clip lines overflowing the view size width
truncate | truncate lines overflowing the view size width
wrap | wrap overflowing words to next line

## Constructor & Destructor Documentation

CMultiLineTextLabel | ( | const CRect & | size | ) |

CMultiLineTextLabel | ( | const CMultiLineTextLabel & |  | ) |
| default

## Member Function Documentation

void drawRect | ( | CDrawContext * | pContext,
|  | const CRect & | updateRect
| ) |  |
| override virtual

called if the view should draw itself

Reimplemented from CView.

bool getAutoHeight | ( |  | ) | const
| inline

returns true if this view resizes itself according to the contents

LineLayout getLineLayout | ( |  | ) | const
| inline

CCoord getMaxLineWidth | ( |  | ) |

return the maximum line width of all lines

bool getVerticalCentered | ( |  | ) | const
| inline

returns true if the view draws the lines vertically centered

void setAutoHeight | ( | bool | state | ) |

automatically resize the view according to the contents (only the height)

Parameters

  state | on or off

void setLineLayout | ( | LineLayout | layout | ) |

void setText | ( | const UTF8String & | txt | ) |
| override virtual

set text

Reimplemented from CTextLabel.

void setTextTruncateMode | ( | TextTruncateMode | mode | ) |
| override virtual

set text truncate mode

Reimplemented from CTextLabel.

void setValue | ( | float | val | ) |
| override virtual

Reimplemented from CControl.

void setVerticalCentered | ( | bool | state | ) |

draw the lines vertical centered

Parameters

  state | on or off

void setViewSize | ( | const CRect & | newSize,
|  | bool | doInvalid = `true`
| ) |  |
| override virtual

set views size

Parameters

  newSize | rect of new size of view
  doInvalid | if true set view dirty

Reimplemented from CTextLabel.

bool sizeToFit | ( |  | ) |
| override virtual

resize view to optimal size

Reimplemented from CTextLabel.

The documentation for this class was generated from the following files:

- ctextlabel.h
- ctextlabel.cpp